/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  org.eclipse.jdt.core.compiler.CharOperation
 *  org.eclipse.jdt.internal.compiler.CompilationResult
 *  org.eclipse.jdt.internal.compiler.DefaultErrorHandlingPolicies
 *  org.eclipse.jdt.internal.compiler.IProblemFactory
 *  org.eclipse.jdt.internal.compiler.ast.CompilationUnitDeclaration
 *  org.eclipse.jdt.internal.compiler.ast.TypeDeclaration
 *  org.eclipse.jdt.internal.compiler.classfmt.ClassFileReader
 *  org.eclipse.jdt.internal.compiler.classfmt.ClassFormatException
 *  org.eclipse.jdt.internal.compiler.env.AccessRuleSet
 *  org.eclipse.jdt.internal.compiler.env.IBinaryType
 *  org.eclipse.jdt.internal.compiler.env.ICompilationUnit
 *  org.eclipse.jdt.internal.compiler.env.NameEnvironmentAnswer
 *  org.eclipse.jdt.internal.compiler.impl.CompilerOptions
 *  org.eclipse.jdt.internal.compiler.lookup.TypeConstants
 *  org.eclipse.jdt.internal.compiler.parser.Parser
 *  org.eclipse.jdt.internal.compiler.parser.ScannerHelper
 *  org.eclipse.jdt.internal.compiler.problem.DefaultProblemFactory
 *  org.eclipse.jdt.internal.compiler.problem.ProblemReporter
 *  org.eclipse.jdt.internal.compiler.util.Util
 */
package org.eclipse.jdt.internal.compiler.batch;

import java.io.File;
import java.io.FilenameFilter;
import java.io.IOException;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;
import org.eclipse.jdt.core.compiler.CharOperation;
import org.eclipse.jdt.internal.compiler.CompilationResult;
import org.eclipse.jdt.internal.compiler.DefaultErrorHandlingPolicies;
import org.eclipse.jdt.internal.compiler.IProblemFactory;
import org.eclipse.jdt.internal.compiler.ast.CompilationUnitDeclaration;
import org.eclipse.jdt.internal.compiler.ast.TypeDeclaration;
import org.eclipse.jdt.internal.compiler.batch.ClasspathLocation;
import org.eclipse.jdt.internal.compiler.batch.CompilationUnit;
import org.eclipse.jdt.internal.compiler.batch.FileSystem;
import org.eclipse.jdt.internal.compiler.classfmt.ClassFileReader;
import org.eclipse.jdt.internal.compiler.classfmt.ClassFormatException;
import org.eclipse.jdt.internal.compiler.env.AccessRuleSet;
import org.eclipse.jdt.internal.compiler.env.IBinaryType;
import org.eclipse.jdt.internal.compiler.env.ICompilationUnit;
import org.eclipse.jdt.internal.compiler.env.NameEnvironmentAnswer;
import org.eclipse.jdt.internal.compiler.impl.CompilerOptions;
import org.eclipse.jdt.internal.compiler.lookup.TypeConstants;
import org.eclipse.jdt.internal.compiler.parser.Parser;
import org.eclipse.jdt.internal.compiler.parser.ScannerHelper;
import org.eclipse.jdt.internal.compiler.problem.DefaultProblemFactory;
import org.eclipse.jdt.internal.compiler.problem.ProblemReporter;
import org.eclipse.jdt.internal.compiler.util.Util;

public class ClasspathDirectory
extends ClasspathLocation {
    private Hashtable directoryCache;
    private String[] missingPackageHolder = new String[1];
    private int mode;
    private String encoding;
    private Hashtable<String, Hashtable<String, String>> packageSecondaryTypes = null;
    Map options;

    ClasspathDirectory(File directory, String encoding, int mode, AccessRuleSet accessRuleSet, String destinationPath, Map options) {
        super(accessRuleSet, destinationPath);
        this.mode = mode;
        this.options = options;
        try {
            this.path = directory.getCanonicalPath();
        }
        catch (IOException iOException) {
            this.path = directory.getAbsolutePath();
        }
        if (!this.path.endsWith(File.separator)) {
            this.path = String.valueOf(this.path) + File.separator;
        }
        this.directoryCache = new Hashtable(11);
        this.encoding = encoding;
    }

    String[] directoryList(String qualifiedPackageName) {
        String[] dirList = (String[])this.directoryCache.get(qualifiedPackageName);
        if (dirList == this.missingPackageHolder) {
            return null;
        }
        if (dirList != null) {
            return dirList;
        }
        File dir = new File(String.valueOf(this.path) + qualifiedPackageName);
        if (dir.isDirectory()) {
            String parentPackage;
            String packageName;
            int index = qualifiedPackageName.length();
            int last = qualifiedPackageName.lastIndexOf(File.separatorChar);
            while (--index > last && !ScannerHelper.isUpperCase((char)qualifiedPackageName.charAt(index))) {
            }
            if (index <= last || !(last != -1 ? !this.doesFileExist(packageName = qualifiedPackageName.substring(last + 1), parentPackage = qualifiedPackageName.substring(0, last)) : !this.doesFileExist(qualifiedPackageName, Util.EMPTY_STRING))) {
                dirList = dir.list();
                if (dirList == null) {
                    dirList = CharOperation.NO_STRINGS;
                }
                this.directoryCache.put(qualifiedPackageName, dirList);
                return dirList;
            }
        }
        this.directoryCache.put(qualifiedPackageName, this.missingPackageHolder);
        return null;
    }

    boolean doesFileExist(String fileName, String qualifiedPackageName) {
        String[] dirList = this.directoryList(qualifiedPackageName);
        if (dirList == null) {
            return false;
        }
        int i = dirList.length;
        while (--i >= 0) {
            if (!fileName.equals(dirList[i])) continue;
            return true;
        }
        return false;
    }

    @Override
    public List fetchLinkedJars(FileSystem.ClasspathSectionProblemReporter problemReporter) {
        return null;
    }

    @Override
    public NameEnvironmentAnswer findClass(char[] typeName, String qualifiedPackageName, String qualifiedBinaryFileName) {
        return this.findClass(typeName, qualifiedPackageName, qualifiedBinaryFileName, false);
    }

    @Override
    public NameEnvironmentAnswer findClass(char[] typeName, String qualifiedPackageName, String qualifiedBinaryFileName, boolean asBinaryOnly) {
        boolean sourceExists;
        if (!this.isPackage(qualifiedPackageName)) {
            return null;
        }
        String fileName = new String(typeName);
        boolean binaryExists = (this.mode & 2) != 0 && this.doesFileExist(String.valueOf(fileName) + ".class", qualifiedPackageName);
        boolean bl = sourceExists = (this.mode & 1) != 0 && this.doesFileExist(String.valueOf(fileName) + ".java", qualifiedPackageName);
        if (sourceExists && !asBinaryOnly) {
            String fullSourcePath = String.valueOf(this.path) + qualifiedBinaryFileName.substring(0, qualifiedBinaryFileName.length() - 6) + ".java";
            if (!binaryExists) {
                return new NameEnvironmentAnswer((ICompilationUnit)new CompilationUnit(null, fullSourcePath, this.encoding, this.destinationPath), this.fetchAccessRestriction(qualifiedBinaryFileName));
            }
            String fullBinaryPath = String.valueOf(this.path) + qualifiedBinaryFileName;
            long binaryModified = new File(fullBinaryPath).lastModified();
            long sourceModified = new File(fullSourcePath).lastModified();
            if (sourceModified > binaryModified) {
                return new NameEnvironmentAnswer((ICompilationUnit)new CompilationUnit(null, fullSourcePath, this.encoding, this.destinationPath), this.fetchAccessRestriction(qualifiedBinaryFileName));
            }
        }
        if (binaryExists) {
            try {
                String typeSearched;
                ClassFileReader reader = ClassFileReader.read((String)(String.valueOf(this.path) + qualifiedBinaryFileName));
                String string = typeSearched = qualifiedPackageName.length() > 0 ? String.valueOf(qualifiedPackageName.replace(File.separatorChar, '/')) + "/" + fileName : fileName;
                if (!CharOperation.equals((char[])reader.getName(), (char[])typeSearched.toCharArray())) {
                    reader = null;
                }
                if (reader != null) {
                    return new NameEnvironmentAnswer((IBinaryType)reader, this.fetchAccessRestriction(qualifiedBinaryFileName));
                }
            }
            catch (IOException iOException) {
            }
            catch (ClassFormatException classFormatException) {}
        }
        return null;
    }

    public NameEnvironmentAnswer findSecondaryInClass(char[] typeName, String qualifiedPackageName, String qualifiedBinaryFileName) {
        if (TypeConstants.PACKAGE_INFO_NAME.equals(typeName)) {
            return null;
        }
        String typeNameString = new String(typeName);
        boolean prereqs = this.options != null && this.isPackage(qualifiedPackageName) && (this.mode & 1) != 0 && this.doesFileExist(String.valueOf(typeNameString) + ".java", qualifiedPackageName);
        return prereqs ? null : this.findSourceSecondaryType(typeNameString, qualifiedPackageName, qualifiedBinaryFileName);
    }

    @Override
    public boolean hasAnnotationFileFor(String qualifiedTypeName) {
        int pos = qualifiedTypeName.lastIndexOf(47);
        if (pos != -1 && pos + 1 < qualifiedTypeName.length()) {
            String fileName = String.valueOf(qualifiedTypeName.substring(pos + 1)) + ".eea";
            return this.doesFileExist(fileName, qualifiedTypeName.substring(0, pos));
        }
        return false;
    }

    private Hashtable<String, String> getPackageTypes(String qualifiedPackageName) {
        File[] listFiles;
        Hashtable<String, String> packageEntry = new Hashtable<String, String>();
        String[] dirList = (String[])this.directoryCache.get(qualifiedPackageName);
        if (dirList == this.missingPackageHolder || dirList == null) {
            return packageEntry;
        }
        File dir = new File(String.valueOf(this.path) + qualifiedPackageName);
        File[] fileArray = listFiles = dir.isDirectory() ? dir.listFiles() : null;
        if (listFiles == null) {
            return packageEntry;
        }
        int i = 0;
        int l = listFiles.length;
        while (i < l) {
            String s;
            File f = listFiles[i];
            if (!f.isDirectory() && (s = f.getAbsolutePath()) != null && (s.endsWith(".java") || s.endsWith(".JAVA"))) {
                TypeDeclaration[] types;
                CompilationUnit cu = new CompilationUnit(null, s, this.encoding, this.destinationPath);
                CompilationResult compilationResult = new CompilationResult(cu.getContents(), 1, 1, 10);
                ProblemReporter problemReporter = new ProblemReporter(DefaultErrorHandlingPolicies.proceedWithAllProblems(), new CompilerOptions(this.options), (IProblemFactory)new DefaultProblemFactory());
                Parser parser = new Parser(problemReporter, false);
                parser.reportSyntaxErrorIsRequired = false;
                CompilationUnitDeclaration unit = parser.parse((ICompilationUnit)cu, compilationResult);
                TypeDeclaration[] typeDeclarationArray = types = unit != null ? unit.types : null;
                if (types != null) {
                    int j = 0;
                    int k = types.length;
                    while (j < k) {
                        char[] name;
                        TypeDeclaration type = types[j];
                        char[] cArray = name = type.isSecondary() ? type.name : null;
                        if (name != null) {
                            packageEntry.put(new String(name), s);
                        }
                        ++j;
                    }
                }
            }
            ++i;
        }
        return packageEntry;
    }

    private NameEnvironmentAnswer findSourceSecondaryType(String typeName, String qualifiedPackageName, String qualifiedBinaryFileName) {
        String fileName;
        Hashtable<String, String> packageEntry;
        if (this.packageSecondaryTypes == null) {
            this.packageSecondaryTypes = new Hashtable();
        }
        if ((packageEntry = this.packageSecondaryTypes.get(qualifiedPackageName)) == null) {
            packageEntry = this.getPackageTypes(qualifiedPackageName);
            this.packageSecondaryTypes.put(qualifiedPackageName, packageEntry);
        }
        return (fileName = packageEntry.get(typeName)) != null ? new NameEnvironmentAnswer((ICompilationUnit)new CompilationUnit(null, fileName, this.encoding, this.destinationPath), this.fetchAccessRestriction(qualifiedBinaryFileName)) : null;
    }

    @Override
    public char[][][] findTypeNames(String qualifiedPackageName) {
        int length;
        if (!this.isPackage(qualifiedPackageName)) {
            return null;
        }
        File dir = new File(String.valueOf(this.path) + qualifiedPackageName);
        if (!dir.exists() || !dir.isDirectory()) {
            return null;
        }
        String[] listFiles = dir.list(new FilenameFilter(){

            @Override
            public boolean accept(File directory1, String name) {
                String fileName = name.toLowerCase();
                return fileName.endsWith(".class") || fileName.endsWith(".java");
            }
        });
        if (listFiles == null || (length = listFiles.length) == 0) {
            return null;
        }
        char[][][] result = new char[length][][];
        char[][] packageName = CharOperation.splitOn((char)File.separatorChar, (char[])qualifiedPackageName.toCharArray());
        int i = 0;
        while (i < length) {
            String fileName = listFiles[i];
            int indexOfLastDot = fileName.indexOf(46);
            result[i] = CharOperation.arrayConcat((char[][])packageName, (char[])fileName.substring(0, indexOfLastDot).toCharArray());
            ++i;
        }
        return result;
    }

    @Override
    public void initialize() throws IOException {
    }

    @Override
    public boolean isPackage(String qualifiedPackageName) {
        return this.directoryList(qualifiedPackageName) != null;
    }

    @Override
    public void reset() {
        this.directoryCache = new Hashtable(11);
    }

    public String toString() {
        return "ClasspathDirectory " + this.path;
    }

    @Override
    public char[] normalizedPath() {
        if (this.normalizedPath == null) {
            this.normalizedPath = this.path.toCharArray();
            if (File.separatorChar == '\\') {
                CharOperation.replace((char[])this.normalizedPath, (char)'\\', (char)'/');
            }
        }
        return this.normalizedPath;
    }

    @Override
    public String getPath() {
        return this.path;
    }

    @Override
    public int getMode() {
        return this.mode;
    }
}

